package sun.security.util;

import jdk.internal.util.Preconditions;
import java.security.ProviderException;
import java.util.List;
import java.util.function.BiFunction;

public final class ArrayUtil
{
    private static final BiFunction<String, List<Integer>, ArrayIndexOutOfBoundsException> AIOOBE_SUPPLIER;
    
    public ArrayUtil() {
    }
    
    public static void blockSizeCheck(int n, int n2) {
        if (n % n2 != 0) {
            throw new ProviderException("Internal error in input buffering");
        }
        return;
    }
    
    public static void nullAndBoundsCheck(byte[] array, int fromIndex, int size) {
        Preconditions.checkFromIndexSize(fromIndex, size, array.length, ArrayUtil.AIOOBE_SUPPLIER);
    }
    
    private static void swap(byte[] array, int n, int n2) {
        int n3 = array[n];
        array[n] = array[n2];
        array[n2] = n3;
    }
    
    public static void reverse(byte[] array) {
        for (int i = 0, n = array.length - 1; i < n; ++i, --n) {
            swap(array, i, n);
        }
    }
    
    static {
        AIOOBE_SUPPLIER = Preconditions.outOfBoundsExceptionFormatter(ArrayIndexOutOfBoundsException::new);
    }
}
